#include <cstdio>
#include <cstdlib>
#include <string>
#include <iostream>
#include <vector>
using namespace std;

string process(string& s) {
	vector<char> res = vector<char>();
	for(int i = 0; i < s.size()-1; ++i) {
		if(s[i] == '/') {
			i += 2;
		} else if(s[i] == '\\') {
			res.pop_back();
			res.pop_back();
		} else if(s[i] == '>') {
			i += 3;
		} else if(s[i] == '<') {
			res.pop_back();
			res.pop_back();
			res.pop_back();
		} else {
			res.push_back(s[i]);
		}
	}
	string result;
	for(int i = 0; i < res.size(); ++i) {
		result += res[i];
	}
	return result;
}

int powm(int n, int p, int m) {
	if(p == 0) return 1;
	int res = powm(n, p>>1, m) % m;
	res = (res*res) % m;
	if(p % 2)
		res *= n;
	return res % m;
}

int calcp(int x, string& s, int m) {
	int p = 0;
	for(int i = 0; i < s.size(); ++i) {
		p += s[i] * powm(x, s.size()-i-1, m);
		p %= m;
	}
	return p;
}

int days[] = {0, 31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};
char res[64];
string calcdate(int p) {
	int day = 1, month = 1;
	
	while(p) {
		if(day == days[month]) {
			day = 1;
			++month;
		} else {
			++day;
		}
		--p;
	}
	sprintf(res, "%02d.%02d.2008", day, month);
	
	return string(res);
}

string calchour(int s) {
	int h = s / 60 / 60;
	s -= h * 60 * 60;
	int m = s / 60;
	s -= m * 60;
	int sec = s;
	
	sprintf(res, "%02d:%02d:%02d", h, m, sec);
	return string(res);
}

void solve() {
	int x;
	string s;
	cin>>x>>s;
	s = process(s);
	int pd = calcp(x, s, 366);
	string date = calcdate(pd);
	sort(s.begin(), s.end());
	int ph = calcp(x, s, 86400);
	string hour = calchour(ph);
	cout<<date<<" "<<hour<<endl;
}

int main() {
	int n;
	cin>>n;
	for(int i = 0; i < n; ++i) {
		solve();
	}
	return 0;
}
